/**
 * http://new-dev.ru/
 * author GoldSoft <newdevexpert@gmail.com>
 * Copyright (c) New-Dev.ru
 */

function changeSubaction(sender, value) {
	sender.siblings('input[name=subaction]').val(value);
}

TRAFFCONTROL = {

	linked_select: {
		get_elements: function() {
			return $("select[data-linked_select]");
		},
		init: function(disable_hidden) {
			if (typeof disable_hidden === "undefined")
				disable_hidden = false;
			
			var self = this;
			this.get_elements().change(function() {
				self.exec($(this), disable_hidden);
			});
			
			//this.refresh();
		},
		refresh: function(elements) {
			if (typeof elements === "undefined")
				elements = this.get_elements();

			var self = this;
			$.each(elements, function(i, elem) {
				var $container = $(this).parents(":dataStartsWith(linked_container_)");
				
				if (!$container.length || $container.is(":visible")) {
					self.exec(elem);
				}
			});
		},
		exec: function(element, disable_hidden) {
			var prefix = $(element).data("linked_select");
			TRAFFCONTROL.linkedContainer($(element).val(), prefix, disable_hidden);
		},
	},

	linked_checkbox: {
		get_elements: function() {
			return $("input[data-linked_checkbox]");
		},
		init: function(disable_hidden) {
			if (typeof disable_hidden === "undefined")
				disable_hidden = false;

			var self = this;
			this.get_elements().change(function() {
				self.exec($(this), disable_hidden);
			});
			
			//this.refresh();
		},
		refresh: function(elements) {
			if (typeof elements === "undefined")
				elements = this.get_elements();
			
			var self = this;
			$.each(elements, function(i, elem) {
				var $container = $(this).parents(":dataStartsWith(linked_container_)");
				
				if (!$container.length || $container.is(":visible")) {
					self.exec(elem);
				}
			});
		},
		exec: function(element, disable_hidden) {
			var prefix = $(element).data("linked_checkbox");
			
			if ($(element).prop("checked"))
				TRAFFCONTROL.linkedContainer("1", prefix, disable_hidden);
			else
				TRAFFCONTROL.linkedContainer("0", prefix, disable_hidden);
		},
	},
	
	linkedContainer: function (val, prefix, disable_hidden) {
		var $elements_has = $("[data-linked_container_" + prefix + "~='" + val + "']");
		var $elements_not = $("[data-linked_container_" + prefix + "]").not($elements_has);
		this.toggleContainer($elements_has, $elements_not, disable_hidden);
		
		$elements_has = $("[data-linked_container_" + prefix + "_not~='" + val + "']");
		$elements_not = $("[data-linked_container_" + prefix + "_not]").not($elements_has);
		this.toggleContainer($elements_not, $elements_has, disable_hidden);
	},

	toggleContainer: function ($elements_has, $elements_not, disable_hidden) {
		var kernel = this;
		
		if ($elements_not.length) {
			$elements_not.slideUp("slow", function() {
				if (disable_hidden)
					$elements_not.find(kernel.getDisabledSelectors()).attr("disabled", "disabled");
				
				if ($elements_has.length) {
					$elements_has.slideDown("slow", function() {
						kernel.nextLinked($elements_has, $elements_not);
					}).find(kernel.getDisabledSelectors()).removeAttr("disabled");
				} else {
					kernel.nextLinked($elements_has, $elements_not);
				}
			});

		} else {
			if ($elements_has.length) {
				$elements_has.slideDown("slow", function() {
					kernel.nextLinked($elements_has, $elements_not);
				}).find(kernel.getDisabledSelectors()).removeAttr("disabled");
			}
		}
	},
	
	nextLinked: function ($elements_has, $elements_not, disable_hidden) {
		this.linked_select.refresh($elements_has.find("select[data-linked_select]"));//элемент стал видим - переключаем связанные элементы
		this.hideLinked($elements_not.find("select[data-linked_select]"));//элемент был скрыт - скрываем связанные элементы
		
		this.linked_checkbox.refresh($elements_has.find("input[data-linked_checkbox]"));//элемент стал видим - переключаем связанные элементы
		this.hideLinked($elements_not.find("input[data-linked_checkbox]"));//элемент был скрыт - скрываем связанные элементы
	},
	
	hideLinked: function(elements) {
		$.each(elements, function(i, elem) {
			var prefix = $(elem).data("linked_select");
			if (typeof prefix === "undefined")
				prefix = $(elem).data("linked_checkbox");
			
			$("[data-linked_container_" + prefix + "]").not("[data-linked_container_options_" + prefix + "~='ignore_hide_linked']").slideUp("slow");
			$("[data-linked_container_" + prefix + "_not]").not("[data-linked_container_options_" + prefix + "~='ignore_hide_linked']").slideUp("slow");
		});
	},
	
	disableHidden: function(elements) {
		if (typeof elements === "undefined")
			elements = $(":dataStartsWith(linked_container_):hidden");
		
		elements.find(this.getDisabledSelectors()).attr("disabled", "disabled");
	},
	
	getDisabledSelectors: function () {
		return "input[name='required_fields[]']";
	},
	
	inWindow: function() {
		if (typeof jQuery.fn.inWindow === "undefined") {
			jQuery.fn.inWindow = function() {
				var scrollTop = $(window).scrollTop() + 50;/*40*/
				var windowHeight = $(window).height();
				var scrollBottom = scrollTop + windowHeight;
				var result = [];
				var top, bottom, temp, ratio = 0;
				
				this.each(function() {
					var el = $(this);
					var offset = el.offset();
					var el_bottom = el.height() + offset.top;

					if ((offset.top > scrollTop && offset.top < scrollBottom) || (el_bottom > scrollTop && el_bottom < scrollBottom) || (offset.top < scrollTop && el_bottom > scrollBottom)) {
						top = Math.max(offset.top, scrollTop);
						bottom = Math.min(el_bottom, scrollBottom);
						
						temp = (bottom - top) / (el_bottom - offset.top);
						if (temp > ratio) {
							ratio = temp;
							result[0] = this;
						}
					}
				});

				return $(result);
			};
		}
	},
	
	dataStartsWith: function() {
		if (typeof jQuery.expr[":"].dataStartsWith === "undefined") {
			
			jQuery.extend(jQuery.expr[":"], { 
				"dataStartsWith" : function(el, i, p, n) {  
					var pCamel = p[3].replace(/-([a-z])/ig, function(m, $1) {
						return $1.toUpperCase();
					});
					return Object.keys(el.dataset).some(function(i, v){
						return i.indexOf(pCamel) > -1;
					});
				}
			});
		}
	},
	
};



function ndShowMessage($message, delay) {
	if (typeof delay === "undefined")
		delay = 2000;
	
	ShowLoading($message);
	$("#loading-layer").css({"z-index":"9999"});
	setTimeout(function() {
		$("#loading-layer").css({"z-index":"99"});
		HideLoading();
	}, delay);
}

function ndSetCookie(name, value, days) {
    var expires = "";
    if (days) {
        var date = new Date();
        date.setTime(date.getTime() + (days*24*60*60*1000));
        expires = "; expires=" + date.toUTCString();
    }
    document.cookie = name + "=" + (value || "")  + expires + "; path=/";
}


function submitCurrentForm() {
	var $form = $("form.traffcontrol_ajax_form:visible")
		.has("button[type=submit]:visible, input[type=submit]:visible")
		.inWindow();
	$form.submit();
	return false;
}

//отправка формы по нажатию горячих клавиш
submit_hotkey = {
	init: function() {//назначаем обработчик нажатия на Ctrl + Enter
		var isCtrl = false;
		$(document).keyup(function (e) {
			if (e.which == 17)
				isCtrl = false;
		}).keydown(function (e) {
			if (e.which == 17)
				isCtrl = true;
			if (e.which == 13 && isCtrl == true) {//13 - Enter, 32 - Space
				return submitCurrentForm();
			}
		});
	}
};

function saveOrderingOnClick() {
	$("#save_ordering_button").click(function() {
		ShowLoading("");
		$.post(TRAFFCONTROL_OPTIONS.ADMIN_URL, {"action": "ajax.from_tab2", "subaction": "update_ordering", "ids": JSON.stringify($("tbody.go-sortable").sortable("toArray")), "user_hash": TRAFFCONTROL_OPTIONS.USER_HASH}, function( data ) {
			TRAFFCONTROL_KERNEL.showResponse(data);
		}, "json")
		.fail(function(response) {
			HideLoading();
			TRAFFCONTROL_KERNEL.showAjaxError(response);
		});
		
		return false;
	});
}

function changeICheck($container, global_checked) {
	$.each($container.find("input.switch.icheck"), function() {
		var default_checked = $(this).data("default-checked");
			checked = (typeof default_checked !== "undefined") ? default_checked : global_checked;
		
		$(this).on("ifChanged", function(event) {
			$(this).trigger("change", event);
		});
	});
}

function beautyFormControls($container) {
	$.each($container.find("input.switch").not("[data-switchery=true]"), function(i, elem) {
		new Switchery(elem, {color: "#4CAF50"});
	});

	$container.find("select.uniform").not("[data-selectpicker=true]").selectpicker().attr("data-selectpicker", true);
	//$container.find("select[data-linked_select]").linked_select();
}



jQuery(document).ready(function($) {
	TRAFFCONTROL.inWindow();
	TRAFFCONTROL.dataStartsWith();
	TRAFFCONTROL.linked_checkbox.init(true);
	TRAFFCONTROL.linked_select.init(true);
	TRAFFCONTROL.disableHidden();
	TRAFFCONTROL_KERNEL.bindAjaxTraffControl();
	
	
	$("form.traffcontrol_ajax_form").submit(function() {
		ShowLoading("");
		$.post(TRAFFCONTROL_OPTIONS.ADMIN_URL, $(this).serialize(), function( data ) {
			TRAFFCONTROL_KERNEL.showResponse(data);
		}, "json")
		.fail(function(response) {
			HideLoading();
			TRAFFCONTROL_KERNEL.showAjaxError(response);
		});

		return false;
	});


	$("ul.nav-tabs > li > a").on("shown.bs.tab", function(e) {
		var id = $(e.target).attr("href").substr(1);
		ndSetCookie("traffcontrol_active_tab", id.replace( /^\D+/g, ""), 365);
	});
	
	$("a[data-dismiss='alert']").click(function(e) {
		var id = $(e.target).data("id");
		ndSetCookie("traffcontrol_hide_hint_" + id, 1, 365);
	});

	var $upgrade_tab_caption_container = $("#upgrade_tab_caption_container");
	if ($upgrade_tab_caption_container.length) {
		$.post(TRAFFCONTROL_OPTIONS.ADMIN_URL, {"action": "ajax.get_upgrades_info", "user_hash": TRAFFCONTROL_OPTIONS.USER_HASH}, function( data ) {
			if (data.msg) {
				$upgrade_tab_caption_container.html(data.msg.title);
				$("#upgrade_tab_body_container").html(data.msg.text);
			}
			
			if (data.status == "ok") {
				$("#upgrade_tab_buttons_container").fadeIn("slow");
			}
		}, "json");
	}

	submit_hotkey.init();

	changeICheck($("form.traffcontrol_ajax_form"));
});