<?php
/**
 * http://new-dev.ru/
 * author GoldSoft <newdevexpert@gmail.com>
 * Copyright (c) New-Dev.ru
 */

namespace TraffControl;

@error_reporting(E_ALL ^ E_NOTICE);
@ini_set('display_errors', true);
@ini_set('html_errors', false);
@ini_set('error_reporting', E_ALL ^ E_NOTICE);

define('IS_AJAX', true);


if ($traffcontrol->user_group != TraffControl::ADMIN_USERGROUP_ID)
	$traffcontrol->helper->showMsgError('Доступ вашей группе запрещен');

if (!$action = POST('action'))
	$traffcontrol->helper->showMsgError('Не указана операция');

if (!$str = POST('user_hash') or $str != $traffcontrol->user_hash)
	$traffcontrol->helper->showMsgError('Неверный ключ, попробуйте обновить страницу');

$subaction = POST('subaction');


if ($action == 'ajax.from_tab1') {

	if ($subaction == 'config') {
		$post_fields = $_POST;
		$traffcontrol->helper->emptyRequiredFields($post_fields);
		$post_fields = $traffcontrol->helper->fixMissedElements(POST('fix_missed_integer'), $post_fields);
		$arr = $traffcontrol->helper->arrayMergeRecursiveEx($traffcontrol->config, $post_fields['config_fields']);
		$lang_message = $traffcontrol->helper->createLanguageFile($arr);
		$was_changed = $traffcontrol->helper->arrayDiffRecursive($traffcontrol->config, $arr);

		if ($was_changed) {
			$traffcontrol->helper->writeArrayToFile(ENGINE_DIR.TraffControl::CFG_FILEPATH, $arr);
			$traffcontrol->helper->showMsgOkNotTranslate(lang('Данные обновлены').$lang_message);
		} else {
			$traffcontrol->helper->showMsgError('Нет изменений');
		}
	
	} elseif ($subaction == 'restore_hints') {
		$was_changed = false;
		
		foreach ($_COOKIE as $key => $value) {
			if (strpos($key, 'traffcontrol_hide_hint_') === 0) {
				set_cookie($key, 0, -365);
				$was_changed = true;
			}
		}
		
		if ($was_changed) {
			$traffcontrol->helper->showMsgOk('Подсказки восстановлены');
		} else {
			$traffcontrol->helper->showMsgError('Нет скрытых подсказок');
		}
		
	}
	
} elseif ($action == 'ajax.from_tab2') {
	if (in_array($subaction, array('install', 'ignore')) and !empty($_POST['version'])) {
		$version = preg_replace('#[^\w\.]#', '', $_POST['version']);
		$was_changed = false;

		if ($subaction == 'install') {
			if (empty($traffcontrol->config['secret_buyer_code'])) {
				$traffcontrol->helper->showMsgError('Для установки обновлений необходимо указать ключ покупателя');
			} else {
				$arr = array(
					'loadfile' => $version,
					'currentversion' => $traffcontrol->config['version'],
				);
				$url = TraffControl::UPDATES_API_URL.'&'.http_build_query($arr);
				$temp_filepath = $traffcontrol->helper->mkdir($traffcontrol->cache_path.'archives/').'upgrade.zip';
				
				if ($response = $traffcontrol->helper->loadUrl($url, array('code' => $traffcontrol->config['secret_buyer_code']))) {
					if (strpos($response, 'error|') === 0) {
						$response = str_replace('error|', '', $response);
						$traffcontrol->helper->showMsgErrorNotTranslate($response);
					} else {
						file_put_contents($temp_filepath, $response);
						if (file_exists($temp_filepath)) {
							$was_changed = $traffcontrol->helper->installUpgrade($temp_filepath, $version);
						}
					}
				}

				if ($was_changed) {
					$arr = array('version' => $_POST['version']);
					$arr = $traffcontrol->helper->arrayMergeRecursiveEx($traffcontrol->config, $arr);
					$traffcontrol->helper->writeArrayToFile(ENGINE_DIR.TraffControl::CFG_FILEPATH, $arr);
					$traffcontrol->helper->showMsgOk('Обновление установлено. Перезагрузка...', 'Информация', 'self');
				} else {
					$traffcontrol->helper->showMsgError('Ошибка при установке обновления');
				}
			}
		} elseif ($subaction == 'ignore') {
			$arr = array('ignored_update_version' => $_POST['version']);
			$arr = $traffcontrol->helper->arrayMergeRecursiveEx($traffcontrol->config, $arr);
			$traffcontrol->helper->writeArrayToFile(ENGINE_DIR.TraffControl::CFG_FILEPATH, $arr);
			$traffcontrol->helper->showMsgOk('Обновление добавлено в игнорируемые. Перезагрузка...', 'Информация', 'self');
		}
	} elseif ($subaction == 'config' and !empty($_POST['config_fields'])) {
		$arr = $traffcontrol->helper->arrayMergeRecursiveEx($traffcontrol->config, $_POST['config_fields']);
		$was_changed = $traffcontrol->helper->arrayDiffRecursive($traffcontrol->config, $arr);

		if ($was_changed) {
			$traffcontrol->helper->writeArrayToFile(ENGINE_DIR.TraffControl::CFG_FILEPATH, $arr);
			$traffcontrol->helper->showMsgOk('Данные обновлены');
		} else {
			$traffcontrol->helper->showMsgError('Нет изменений');
		}
	} elseif ($subaction == 'reset_cache') {
		$cache_key = $traffcontrol->helper->getUpgradeCacheKey();
		if ($traffcontrol->helper->unlink($traffcontrol->cache_path.$cache_key.'.tmp')) {
			$traffcontrol->helper->showMsgOk('Кэш сброшен. Перезагрузка...', 'Информация', 'self');
		} else {
			$traffcontrol->helper->showMsgError('Перезагрузка...', 'Информация', 'self');
		}
	}
	
} elseif ($action == 'ajax.get_upgrades_info') {
	$text = '';
	if ($response = $traffcontrol->helper->loadUrl(TraffControl::UPDATES_API_URL.'&currentversion='.$traffcontrol->config['version'].'&language='.$traffcontrol->config['language'])) {
		$data = json_decode($response, true);

		$cache_key = $traffcontrol->helper->getUpgradeCacheKey();
		$traffcontrol->helper->putCache($cache_key, $response);

		if ($traffcontrol->helper->isActualUpgrade($data['version'])) {
			$title = '<sup style="color:red">'.lang('Есть обновления').'</sup>';
			$text = nl2br($data['description']);
			$traffcontrol->helper->showMsgOkNotTranslate($text, $title);
		} else {
			$title = '<sup>'.lang('Нет').'</sup>';
			$text = '<h6>'.lang('Нет актуальных обновлений').'</h6>';
		}
	} else {
		$title = '<sup>'.lang('Ошибка').'</sup>';
		$text = '<sup>'.lang('Возникла ошибка в процессе проверки обновлений').'</sup>';
	}

	$traffcontrol->helper->showMsgErrorNotTranslate($text, $title);	
}

$traffcontrol->helper->showMsgError('Возникла ошибка при выполнении операции');