<?php
/**
 * http://new-dev.ru/
 * author GoldSoft <newdevexpert@gmail.com>
 * Copyright (c) New-Dev.ru
 */

namespace TraffControl;

(defined('DATALIFEENGINE') and defined('LOGGED_IN')) or exit('Access Denied');

if ($traffcontrol->user_group != TraffControl::ADMIN_USERGROUP_ID)
	exit('Access Denied');

if ($traffcontrol->helper->isVersionLess('12')) {
	$traffcontrol->helper->addCSSFile($traffcontrol->rel_module_url.'admin/lib/bootstrap/css/bootstrap.css', true);
	$traffcontrol->helper->addCSSFile($traffcontrol->rel_module_url.'admin/lib/bootstrap/css/bootstrap-theme.css', true);
	$traffcontrol->helper->addCSSFile($traffcontrol->rel_module_url.'lib/jquery.growl/jquery.growl.css', true);
	$traffcontrol->helper->addCSSFile($traffcontrol->rel_module_url.'admin/lib/fontawesome/styles.min.css', true);
	
	if ($traffcontrol->helper->isVersionLess('10.2')) {
		$traffcontrol->helper->addCSSFile('engine/skins/chosen/chosen.css', true);
		$traffcontrol->helper->addCSSFile($traffcontrol->rel_module_url.'admin/lib/jquery-ui-1.12.1/jquery-ui.min.css', true);
		
		$traffcontrol->helper->addJsFile($traffcontrol->rel_module_url.'admin/lib/jquery1.11.1/jquery.js', true);
		$traffcontrol->helper->addJsFile($traffcontrol->rel_module_url.'admin/lib/jquery-ui-1.12.1/jquery-ui.min.js', true);
		$traffcontrol->helper->addJsFile($traffcontrol->rel_module_url.'admin/lib/bootstrap/js/bootstrap.js', true);
		$traffcontrol->helper->addJsFile('engine/skins/chosen/chosen.js');
	}
	
	$traffcontrol->helper->addJsFile($traffcontrol->rel_module_url.'lib/jquery.growl/jquery.growl.js', true);
	$traffcontrol->helper->addJsFile($traffcontrol->rel_module_url.'lib/jquery.growl/jquery.growl.init.js', true);	
}

$traffcontrol->helper->addCSSFile($traffcontrol->rel_module_url.'admin/admin.css', true);

$traffcontrol->helper->addJsFile($traffcontrol->rel_module_url.'kernel.js', true);
$traffcontrol->helper->addJsFile($traffcontrol->rel_module_url.'admin/admin.js', true);


$tabs = array(
	array('id' => 1, 'title' => __('Настройки')),
	array('id' => 2, 'title' => __('Обновления модуля'), 'header_html' => $traffcontrol->helper->getUpgradeTabCaption()),
);

if (!$active_tab = (int)GET('tab') or $active_tab > count($tabs))
	$active_tab = 1;

if ($active_tab == 2) {
	if ($traffcontrol->helper->isVersionLarger('10.1'))
		$traffcontrol->helper->addJsFile($traffcontrol->rel_module_url.'admin/lib/jquery-ui-1.12.1.custom/jquery-ui.min.js', true);
}


echoheader(__('TraffControl - Управление трафиком сайта'), __('Настройки модуля'));


echo $traffcontrol->helper->renderCSSLinks();//Set stylesheet links
echo $traffcontrol->helper->renderCSSCode();//Set stylesheet declarations
echo $traffcontrol->helper->renderJsLinks();//Set script file links
echo $traffcontrol->helper->renderJsCode();//Set script declarations


echo $traffcontrol->helper->hint(__FILE__.'0', 'Для удобства работы можно использовать отправку форм по сочетанию клавиш <code>Ctrl + Enter</code>. Чтобы после окончания настроек отправить данные, кроме кнопки в нижней части формы, можно использовать сочетание данных клавиш.');
?>

<div class="panel">

	<div class="panel-header">
		<ul class="nav nav-tabs nav-tabs-left">
			<?php foreach ($tabs as $tab) { ?>
			<li class="<?php echo ($active_tab == $tab['id']) ? 'active' : ''; ?>">
				<a <?php echo $traffcontrol->buildChangeTabTagPart($tab['id']); ?>>
					<?php echo $tab['title'].safe_array_access($tab, 'header_html'); ?>
				</a>
			</li>
			<?php } ?>
		</ul>
	</div>

	<div class="panel-content">
		<div class="tab-content">

			<div class="tab-pane active">
				<?php require_once $traffcontrol->module_path.'admin/tab'.$active_tab.'.php'; ?>
			</div>
			
		</div>
	</div>

</div>


<div class="panel">
	<div class="panel-content">
		<div class="panel-body">
			&copy; <?php echo (date('Y') == 2020 ? '' : '2020 - ').date('Y г.').' '.__('Модуль <b>TraffControl - Управление трафиком сайта</b>. Версия ').'<b>'.$traffcontrol->config['version'].'</b>. '.__('Разработано в'); ?> <a href="http://new-dev.ru" target="_blank">New-Dev.ru</a>
		</div>
	</div>
</div>


<script>
var TRAFFCONTROL_OPTIONS = JSON.parse('<?php echo $traffcontrol->helper->getJsOptions(); ?>');
</script>


<?php echo $traffcontrol->helper->renderHtmlCode(true);//Set HTML code ?>
<?php echo $traffcontrol->helper->renderCSSLinks(true);//Set stylesheet links ?>
<?php echo $traffcontrol->helper->renderJsLinks(true);//Set script file links ?>
<?php echo $traffcontrol->helper->renderJsCode(true);//Set script declarations ?>


<?php echofooter(); ?>