<?php
/**
 * http://new-dev.ru/
 * author GoldSoft <newdevexpert@gmail.com>
 * Copyright (c) New-Dev.ru
 */

namespace TraffControl;

defined('DATALIFEENGINE') or exit('Access Denied');
?>

<form action="" class="traffcontrol_ajax_form" method="post" autocomplete="off">
	<div class="panel panel-flat">
		<div class="panel-body">
			<?php echo $traffcontrol->helper->hint(__FILE__.'1', 'Модуль предназначен для управления трафиком сайта в целях защиты основного домена от блокировок. В настройках прежде всего указывается дополнительный домен или поддомен, который должен быть алиасом (псевдонимом), то есть, указывать в ту же папку на хостинге, что и основной домен. При каждом посещении сайта модуль проверяет &laquo;User-Agent&raquo; посетителя, и если он содержит определенные слова, например, &laquo;googlebot&raquo;, &laquo;yandexbot&raquo; и т.д., то показывается основной домен. Если пользователь перешел из поиска - показывается дополнительный домен (поддомен). Если обычный пользователь не перешел из поиска - то показывается заглушка (если это включено в соответствующем параметре).'); ?>
			
		</div>
		<div class="table-responsive">
			<table class="table table-striped">
				<?php
				$traffcontrol->helper->showRow(
					'Включить модуль',
					'',
					$traffcontrol->helper->makeCheckbox(
						'config_fields[state]',
						$traffcontrol->config['state']
					)
				);
				
				$traffcontrol->helper->showRow(
					'Домен в поиске',
					'Домен который сейчас находится в поисковой выдаче. Если не заполнять, то будет использован домен, указанный в настройках движка.',
					$traffcontrol->helper->makeInputText(
						'config_fields[base_domain]',
						$traffcontrol->config['base_domain']
					),
					'',
					array(),
					true
				);
				
				$traffcontrol->helper->showRow(
					'Домен или поддомен для пользователей',
					'Дополнительный домен или поддомен на который будут попадать пользователи',
					$traffcontrol->helper->makeInputText(
						'config_fields[user_domain]',
						$traffcontrol->config['user_domain']
					),
					'',
					array(),
					true
				);
				
				$traffcontrol->helper->showRow(
					'Закрыть домен для пользователей от индексации',
					'Если включено, то домен (поддомен) для пользователей будет закрыт от индексации с помощью тега &laquo;robots&raquo;',
					$traffcontrol->helper->makeCheckbox(
						'config_fields[user_domain_noindex]',
						$traffcontrol->config['user_domain_noindex']
					)
				);
				
				$arr = array(
					TraffControl::USER_ACCESS_ACTION_STUB => __('Выдать страницу заглушки (сайт ничего не нарушает)'),
					TraffControl::USER_ACCESS_ACTION_USER_DOMAIN => __('Сделать редирект на поддомен для пользователей'),
				);
				$traffcontrol->helper->showRow(
					'Вход напрямую пользователя',
					'Когда пользователь заходит напрямую на сайт (через закладки или вводит адрес в браузер)',
					$traffcontrol->helper->makeDropdown(
						$arr,
						'config_fields[user_direct_access_action]',
						$traffcontrol->config['user_direct_access_action'],
						'data-linked_select="user_direct_access_action"'
					)
				);
				
				$traffcontrol->helper->showRow(
					'HTML код заглушки',
					'HTML код, который используется для вывода заглушки на сайте',
					$traffcontrol->helper->makeTextarea(
						'config_fields[stub_html_code]',
						$traffcontrol->config['stub_html_code']
					),
					$traffcontrol->helper->makeLinkedPart('user_direct_access_action', TraffControl::USER_ACCESS_ACTION_STUB)
				);
				
				
				$arr = array(
					'500' => 'HTTP/1.1 500 Internal Server Error',
					'404' => 'HTTP/1.1 404 Not Found',
					'200' => 'HTTP/1.1 200 OK',
				);
				$traffcontrol->helper->showRow(
					'HTTP код ответа',
					'',
					$traffcontrol->helper->makeDropdown(
						$arr,
						'config_fields[http_response_code]',
						$traffcontrol->config['http_response_code']
					),
					$traffcontrol->helper->makeLinkedPart('user_direct_access_action', TraffControl::USER_ACCESS_ACTION_STUB)
				);
				
				$traffcontrol->helper->showRow(
					'Пропускать на поддомен только мобильный трафик',
					'Если включено, то только пользователи зашедшие с мобильных устройств через поисковые системы будут перенаправлены на пользовательский поддомен, а десктопным устройствам будет показана заглушка (если это выбрано в предыдущем параметре)',
					$traffcontrol->helper->makeCheckbox(
						'config_fields[user_domain_only_for_mobile]',
						$traffcontrol->config['user_domain_only_for_mobile']
					)
				);
				
				
				$arr = array(
					TraffControl::SEARCHENGINE_ACCESS_ACTION_NONE => __('Ничего не делать'),
					TraffControl::SEARCHENGINE_ACCESS_ACTION_BASE_DOMAIN => __('Редирект на домен с выдачи (главный домен)'),
					TraffControl::SEARCHENGINE_ACCESS_ACTION_BLANK_PAGE => __('Пустая страница'),
					TraffControl::SEARCHENGINE_ACCESS_ACTION_NOINDEX => __('Запрет индексации'),
				);
				$traffcontrol->helper->showRow(
					'Посещение поискового робота',
					'Если робот поисковой системы переходит на дополнительный поддомен - будет применено указанное действие. Запрет индексации производится с помощью тега &laquo;robots&raquo;.',
					$traffcontrol->helper->makeDropdown(
						$arr,
						'config_fields[searchengine_access_action]',
						$traffcontrol->config['searchengine_access_action']
					)
				);
				
				
				$traffcontrol->helper->showRow(
					'Пропускать пользователей с определенных сайтов',
					'Включить/отключить игнорирование заглушки, если пользователь перешел с определенного сайта. Можно использовать например, если вы размещаете рекламу на других сайтах в виде ссылок, по которым посетители могут переходить на ваш сайт.',
					$traffcontrol->helper->makeCheckbox(
						'config_fields[sites_that_open_access_on]',
						$traffcontrol->config['sites_that_open_access_on'],
						'data-linked_checkbox="sites_that_open_access_on"'
					)
				);
				
				$traffcontrol->helper->showRow(
					'Список сайтов для игнорирования заглушки',
					'Если пользователь перешел с любого из этих сайтов, то модуль пропустит его на дополнительный поддомен, вместо того, чтобы показать заглушку. Сайты необходимо указывать по одному в каждой строке.',
					$traffcontrol->helper->makeTextarea(
						'config_fields[sites_that_open_access]',
						$traffcontrol->config['sites_that_open_access']
					),
					$traffcontrol->helper->makeLinkedPart('sites_that_open_access_on')
				);
				
				
				$traffcontrol->helper->showRow(
					'Пропускать пользователей с GET параметрами',
					'Включить/отключить игнорирование заглушки, если пользователь перешел по ссылке с определенными GET параметрами',
					$traffcontrol->helper->makeCheckbox(
						'config_fields[get_params_that_open_access_on]',
						$traffcontrol->config['get_params_that_open_access_on'],
						'data-linked_checkbox="get_params_that_open_access_on"'
					)
				);
				
				$traffcontrol->helper->showRow(
					'Список GET параметров для игнорирования заглушки',
					'Если пользователь перешел с по ссылке с любым из этих параметров, то модуль пропустит его на дополнительный поддомен, вместо того, чтобы показать заглушку. Параметры необходимо указывать по одному в каждой строке.',
					$traffcontrol->helper->makeTextarea(
						'config_fields[get_params_that_open_access]',
						$traffcontrol->config['get_params_that_open_access']
					),
					$traffcontrol->helper->makeLinkedPart('get_params_that_open_access_on')
				);
				
				$traffcontrol->helper->showRow(
					'Список User-Agent ботов',
					'Список для определения поисковых ботов. Необходимо указывать по одному в каждой строке. При сравнении учитывается регистр символов в слове.',
					$traffcontrol->helper->makeTextarea(
						'config_fields[bot_list]',
						$traffcontrol->config['bot_list']
					)
				);
				
				
				$traffcontrol->helper->showRow(
					'Включить эмуляцию бота',
					'Если включено и вы зайдете на сайт с определенным IP-адресом - то модуль будет считать вас как бота поисковой системы, можно включить для тестирования',
					$traffcontrol->helper->makeCheckbox(
						'config_fields[bot_emulation_ip_on]',
						$traffcontrol->config['bot_emulation_ip_on'],
						'data-linked_checkbox="bot_emulation_ip_on"'
					)
				);
				
				$traffcontrol->helper->showRow(
					'IP-адрес для эмуляции бота',
					'В целях тестирования укажите свой IP-адрес и модуль будет определять вас как бота поисковой системы',
					$traffcontrol->helper->makeInputText(
						'config_fields[bot_emulation_ip]',
						$traffcontrol->config['bot_emulation_ip']
					),
					$traffcontrol->helper->makeLinkedPart('bot_emulation_ip_on'),
					array(),
					true
				);
				
				
				$traffcontrol->helper->showRow(
					'Включить куку для повторного визита',
					'Если включено и если пользователю после проверок будет разрешен вход на дополнительный поддомен, то сохраняется кука, которая при повторном визите снова пропускает пользователя уже без дополнительных проверок',
					$traffcontrol->helper->makeCheckbox(
						'config_fields[cookie_that_open_access_on]',
						$traffcontrol->config['cookie_that_open_access_on'],
						'data-linked_checkbox="cookie_that_open_access_on"'
					)
				);
				
				$traffcontrol->helper->showRow(
					'Название куки для повторного визита',
					'Название куки, которая сохраняется в браузере пользователя',
					$traffcontrol->helper->makeInputText(
						'config_fields[cookie_that_open_access_name]',
						$traffcontrol->config['cookie_that_open_access_name']
					),
					$traffcontrol->helper->makeLinkedPart('cookie_that_open_access_on'),
					array(),
					true
				);
				
				$traffcontrol->helper->showRow(
					'Срок жизни куки для повторного визита',
					'Срок жизни куки (в часах), которая сохраняется в браузере пользователя',
					$traffcontrol->helper->makeInputText(
						'config_fields[cookie_that_open_access_expired_hours]',
						$traffcontrol->config['cookie_that_open_access_expired_hours']
					),
					$traffcontrol->helper->makeLinkedPart('cookie_that_open_access_on'),
					array(),
					true
				);
				
				
				$traffcontrol->helper->showRow(
					'Отображать для всех пользователей',
					'Если выключено - то все функции модуля на сайте будут доступны только для администратора (можно использовать для тестирования)',
					$traffcontrol->helper->makeCheckbox(
						'config_fields[enable_for_all]',
						$traffcontrol->config['enable_for_all']
					)
				);
				
				$traffcontrol->helper->showRow(
					'IP-адрес для тестирования',
					'Если указать IP-адрес для тестирования - все функции модуля на сайте будут доступны только для него (можно использовать для тестирования)',
					$traffcontrol->helper->makeInputText(
						'config_fields[test_ip]',
						$traffcontrol->config['test_ip']
					)
				);
				
				$traffcontrol->helper->showRow(
					'Восстановить подсказки',
					'Восстановить все скрытые подсказки в настройках модуля в админпанели',
					'<a href="#" data-do="ajax-traffcontrol" data-vars="action=ajax.from_tab1|subaction=restore_hints" title="'.__('Восстановить все скрытые подсказки').'" class="btn bg-brown-600 btn-sm">'.__('Восстановить').'</a>'
				);
				
				$traffcontrol->helper->showRow(
					'Код используемого языка',
					'Для использования другого языка, укажите его код (название не принципиально), например: английский язык - &laquo;en&raquo;, немецкий язык - &laquo;de&raquo;. Для перевода будет использоваться языковой конфиг-файл в соответствующей папке в каталоге &laquo;/engine/modules/traffcontrol/language/&raquo;. Если данный файл не существует, то он будет автоматически создан при сохранении настроек и после посещения всех страниц нуждающихся в переводе, файл автоматически заполняется строками, которые необходимо перевести.',
					$traffcontrol->helper->makeInputText(
						'config_fields[language]',
						$traffcontrol->config['language']
					)
				);
				?>

			</table>
		</div>
	</div>
	<div style="padding:5px 0 20px 20px;">
		<input type="hidden" name="action" value="ajax.from_tab1" />
		<input type="hidden" name="subaction" value="config" />
		<input type="hidden" name="user_hash" value="<?php echo $traffcontrol->user_hash; ?>" />
		<button type="submit" class="btn bg-teal btn-raised position-left btn-green">
			<i class="fa fa-floppy-o position-left"></i><?php echo __('Сохранить'); ?>
		</button>
	</div>
</form>