<?php
/**
 * http://new-dev.ru/
 * author GoldSoft <newdevexpert@gmail.com>
 * Copyright (c) New-Dev.ru
 */

defined('DATALIFEENGINE') or exit('Access Denied');

require 'functions_ns.php';

if (!function_exists('only_alias')) {
	function only_alias($value) {
		return preg_replace('#[^0-9a-zA-Z\-\_\.]#', '', $value);
	}
}

if (!function_exists('only_float')) {
	function only_float($value) {
		return preg_replace('#[^0-9\.]#', '', $value);
	}
}

if (!function_exists('only_word')) {
	function only_word($str) {
		return preg_replace('#\W#', '', $str);
	}
}

if (!function_exists('COOKIE')) {
	function COOKIE($name) {
		return isset($_COOKIE[$name]) ? $_COOKIE[$name] : '';
	}
}

if (!function_exists('SESSION')) {
	function SESSION($name) {
		return isset($_SESSION[$name]) ? $_SESSION[$name] : '';
	}
}

if (!function_exists('POST')) {
	function POST() {
		$arg_list = func_get_args();
		$level = $_POST;
		
		foreach ($arg_list as $key) {

			if (!array_key_exists($key, $level)) {
				return '';
			}
			
			$level =& $level[$key];
		}
		
		return $level;
	}
}

if (!function_exists('GET')) {
	function GET() {
		if ($arr = $_GET) {
			$level =& $arr;
			$numargs = func_num_args();
			
			if ($numargs) {
				$arg_list = func_get_args();
				foreach ($arg_list as $key) {
				
					if (!array_key_exists($key, $level)) {
						return '';
					}
					
					$level =& $level[$key];
				}
			}

			return $level;
		}

		return '';
	}
}

if (!function_exists('array_rebuild')) {
	function array_rebuild($rows, $new_key) {
		$arr = array();
		
		foreach ($rows as $k => $row) {
			if (isset($row[$new_key])) {
				$arr[$row[$new_key]] = $row;
			}
		}
		
		return $arr ? $arr : array();
	}
}

if (!function_exists('safe_array_access')) {
	function safe_array_access($array) {
		if ($array and is_array($array)) {
			$numargs = func_num_args();
			$arg_list = func_get_args();

			for ($i = 1; $i < $numargs; $i++) {
				if ($array and (isset($array[$arg_list[$i]]) or array_key_exists($arg_list[$i], $array)))
					$array = $array[$arg_list[$i]];
				else
					return false;
			}
		}

		return $array;
	}
}

if (!function_exists('filter_allowed_keys')) {
	function filter_allowed_keys($data, $allowed) {
		if ($data) {
			if (!is_array($allowed)) {
				$allowed = explode(',', $allowed);
				$allowed = array_map('trim', $allowed);
			}
			
			return array_intersect_key($data, array_flip($allowed));
		}
	}
}

if (!function_exists('fs_log')) {
	function fs_log($value, $showtime = false) {
		$filename = defined('ROOT_DIR') ? ROOT_DIR.'/+fs_log.txt' : './+fs_log.txt';

		if (is_array($value)) {
			ob_start();
			var_dump($value);
			$data = ob_get_clean();
			$log = fopen($filename, 'a');
			fwrite($log, $data);
			fwrite($log, "**********\n");
			fclose($log);

		} else {
			$log = fopen($filename, 'a');

			if ($showtime) {
				$time = date('Y-m-d H:i:s');
				fwrite($log, "$value ($time)\n");
			} else {
				fwrite($log, "$value\n");
			}

			fclose($log);
		}
	}
}

if (!function_exists('print2')) {
	function print2($expression, $noexit = false) {
		if ($expression)
			echo '<pre>',print_r($expression, 1),'</pre>';
		else
			echo 'Empty expression';
		
		if (!$noexit)
			exit;
	}
}