<?php
/**
 * http://new-dev.ru/
 * author GoldSoft <newdevexpert@gmail.com>
 * Copyright (c) New-Dev.ru
 */

namespace TraffControl;

defined('DATALIFEENGINE') or exit('Access Denied');

if (!function_exists('__')) {
	function __($text, $convert_encoding = true, $translate = true) {
		if (!$text)
			return '';
		
		if ($translate and $buffer = lang($text) and $buffer != $text) {
			$text = $buffer;
		} elseif ($convert_encoding) {
			$text = to_win1251($text);
		}
		
		return $text;
	}
}

if (!function_exists('lang')) {
	function lang($text) {
		if ($text) {
			if ($buffer = TraffControl::instance()->helper->lang($text)) {
				$text = $buffer;
			}
		
			return $text;
		}
	}
}

if (!function_exists('to_win1251')) {
	function to_win1251($text) {
		if ($text) {
			if (TraffControl::instance()->helper->isWin1251Charset()) {
				$text = mb_convert_encoding($text, 'WINDOWS-1251', 'UTF-8');
			}
			
			return $text;
		}
	}
}

if (!function_exists('to_utf8')) {
	function to_utf8($text) {
		if ($text) {
			if (TraffControl::instance()->helper->isWin1251Charset()) {
				$text = mb_convert_encoding($text, 'UTF-8', 'WINDOWS-1251');
			}
			
			return $text;
		}
	}
}